% Num. Math. - FS 2014 - Serie 6 Aufgabe 2 - heat equation

function s6_2()
  N=3000;
  N_t=200;

  % x values:
  h = 1/N;
  x = (h:h:(1-h))';

  % evaluate the Source term:
  RHS = cos(2.*pi.*x);

  % Define the initial condition:
  u_0 = 0.*x;

  % construct the matrix (sparse format):
  d = -2.*ones(N-1,1); ud = ones(N-2,1); ld = ud;
  A =  (1./h.^2).*gallery('tridiag',ld,d,ud);

  % Define time Step to reach final time T_end:
  T_end = 2; 
  Dt = T_end/N_t;

  % Do a sparse LR-decomposition of the Matrix I-hA:
  [L,U] = lu(speye(N-1,N-1) - Dt.*A);

  % Do the implicit Euler updates:
  u = u_0;
  for k=1:N_t
    u_new = L\(u - Dt.*RHS);
    u_new = U\u_new;
    u = u_new;
  end

  % Plotting the full solution:
  x_tot = (0:h:1)';
  u_tot = [0;u;0];
  plot(x_tot, u_tot)
  title(['Solution with N = ' num2str(N), ', N_t = ' num2str(N_t)]);
  xlabel('x')
  ylabel('u')
  
  % Save plot
  print('-depsc','pl6_2.eps')     
 
end

 
